function B = Basis(theta,phi,L,re)

% function B = Basis(theta,phi,Ll)
%
% calculates the spherical harmonic basis functions, at {theta, phi} of order
% upto L. (Use for a mirror)
%
% Sameer Shirdhonkar (7 April 2005)
% Modified: 20 Dec 2006				

if(nargin==3)
  re = 1;	% real or complex basis
end

b = SHY(0:L,theta,phi);
B = zeros(size(b,3)*size(b,4),(L+1)^2);
for l=0:L
  if(re==1)	% real
    m = 0;
    B(:,1+l*(l+1)+m) = reshape(b(l+1,m+1,:,:),[numel(b(l+1,m+1,:,:)),1]);
    for m=1:l
      B(:,1+l*(l+1)+m) = sqrt(2) * real(reshape(b(l+1,m+1,:,:),...
      [numel(b(l+1,m+1,:,:)),1]) );
      B(:,1+l*(l+1)-m) = sqrt(2) * imag(reshape(b(l+1,m+1,:,:),...
      [numel(b(l+1,m+1,:,:)),1]) );
    end
  else		% complex
    for m=0:l
      B(:,1+l*(l+1)+m) = reshape(b(l+1,m+1,:,:),[numel(b(l+1,m+1,:,:)),1]);
      B(:,1+l*(l+1)-m) = (-1)^m*conj(B(:,1+l*(l+1)+m));
    end
  end
end
