function f = calcklp(L,p)

% function f = calcklp(L,p)
%
% calculates 0:L sh coefficients of the function f(x) = x^p (x>0) else 0
% 
% Sameer Shirdhonkar (7 April 2005)
% Modified: 20 Dec 2006				


f = zeros(L+1,1);

for l=0:L			% l>p and even l-p
  if(l>p && rem(l-p,2)==0)
    f(l+1) = 0; continue;
  end
  if(l>p)			% l>p and odd l-p
    f(l+1) = sqrt((2*l+1)*pi) * (-1)^((l+p+1)/2) * prod( ((l-p+1)/2:l-p) ./ ...
      (p+1:(p+l+1)/2) ) / (2^l*(l-p));
  else				% l<=p
    if(l==0)
      f(1) = sqrt(pi)/(p+1);
    else
	f(l+1) = sqrt((2*l+1)*pi) * prod( (p-l+1:p) ./ (p-l+1:2:p+l-1) )...
	  /(p+l+1);
    end
  end
end  

f = f' * (1+p)/(2*pi);	% Energy normalization
