
% Sample Usage, for synthetic data:
% Object model is uniform albedo sphere:

n = 25;
theta = repmat((0:pi/n:pi)',1,2*n+1);
phi = repmat(0:pi/n:2*pi,n+1,1);
albedo = ones(size(theta));
N2 =  {theta,phi,albedo};
I = render([1 0 0.5 0 0 0 0.5 0 0],N2,{'ml',[],0.5},[0,0],1);
figure; showsf(I,4,n); 
title('Uniform albedo sphere with SH lighting Y_{00}+0.5Y_{10}+0.5Y_{20}');
drawnow;
fprintf('Solving demo problem ...'); tic;
[err,tmin,alp,Ifit] = gensdp(I,N2,10,'ml',[0,0],0.5);
fprintf('     Done.\n Total time = %g seconds\n', toc);
disp(err)
fprintf('Residual error = %g\n', tmin);
